module Types.ConnectionState
  ( Client (..),
    ConnectedClientsState,
    ConnectedClients,
    initConnectionsState,
  )
where

import ClassyPrelude
import Data.UUID (UUID)
import Network.WebSockets qualified as WS

data Client = Client
  { uuid :: UUID,
    name :: Text,
    conn :: WS.Connection,
    joinedRoom :: Bool
  }

type ConnectedClientsState = TVar ConnectedClients

type ConnectedClients = [Client]

initConnectionsState :: IO ConnectedClientsState
initConnectionsState = newTVarIO newConnectedClients

newConnectedClients :: ConnectedClients
newConnectedClients = []
